<div class="flex flex-col justify-start h-full">
  <div class="form-button-grid">
    <ng-container *ngIf="showDetailed">
      <button mat-flat-button color="primary" (click)="showRanks()">
        {{
          nonDisplayedTaxa.length === 0
            ? "Show genus and species only"
            : "Show all taxonomic ranks"
        }}
      </button>
    </ng-container>

    <ng-container *ngIf="!showDetailed">
      <button mat-flat-button color="primary" (click)="showDetailedResults()">
        View detailed mapping results
      </button>
    </ng-container>
  </div>

  <mat-form-field appearance="outline">
    <mat-label>Filter table</mat-label>
    <input
      matInput
      (keyup)="applyFilter($event)"
      placeholder="find row"
      #input
    />
  </mat-form-field>

  <div class="overflow-auto max-h-full">
    <table mat-table matSort [dataSource]="dataSource">
      <ng-container *ngIf="showDetailed">
        <ng-container [matColumnDef]="'expand'">
          <th mat-header-cell *matHeaderCellDef></th>
          <td mat-cell *matCellDef="let module">
            <ng-container *ngIf="module.isModule">
              <button disableRipple mat-icon-button>
                <mat-icon color="primary">{{
                  expandedModules.includes(module.module) ? "remove" : "add"
                }}</mat-icon>
              </button>
            </ng-container>
          </td>
        </ng-container>
      </ng-container>
      <ng-container
        [matColumnDef]="column"
        *ngFor="let column of displayedColumns.slice(showDetailed ? 1 : 0)"
      >
        <ng-container>
          <th
            [ngClass]="{ hidden: isHidden(column) }"
            mat-header-cell
            *matHeaderCellDef
            mat-sort-header
          >
            {{ column }}
          </th>

          <td
            [ngClass]="{ hidden: isHidden(column) }"
            mat-cell
            *matCellDef="let module"
          >
            {{ module[column] }}
          </td>
        </ng-container>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
      <tr
        [ngClass]="{
          hidden: !row.isModule && !expandedModules.includes(row.module)
        }"
        mat-row
        *matRowDef="let row; columns: displayedColumns"
        (click)="expandModule(row)"
      ></tr>

      <tr class="mat-row" *matNoDataRow>
        <td class="mat-cell">No data matching the filter</td>
      </tr>
    </table>
  </div>
</div>
